const { Structures } = require("discord.js");


module.exports = (client) => {
    const disbut = require("discord-buttons")(client);

    class TextChannel extends Structures.get("TextChannel") {
        async createSlider(userID, embeds) {

            const button_back = new disbut.MessageButton()
                .setStyle('gray')
                .setID('back')
                .setLabel("<<");
            const button_next = new disbut.MessageButton()
                .setStyle('gray')
                .setID('next')
                .setLabel('>>') 

            const allbuttons = [button_back, button_next]

            let msg = await this.send({
                embed: embeds[0], 
                buttons: allbuttons,
                type: 7
            });
        
            const collector = msg.createButtonCollector((button) => button.clicker.user.id === userID, { time: 60000 });
        
            let currentPage = 0;
        
            collector.on('collect', b => {
                b.defer(true)

                if(b.id == "back") {
                    if (currentPage !== 0) {
                        --currentPage;
                        msg.edit({embed:embeds[currentPage], buttons: allbuttons});
                    } else {
                        currentPage = embeds.length - 1
                        msg.edit({embed:embeds[currentPage], buttons: allbuttons});
                    }
                }

                else if(b.id == "next"){
                    if (currentPage < embeds.length - 1) {
                        currentPage++;
                        msg.edit({embed:embeds[currentPage], buttons: allbuttons});
                    } else {
                        currentPage = 0
                        msg.edit({embed:embeds[currentPage], buttons: allbuttons});
                    }
                }
            });
            collector.on('end', collected => {
                msg.edit(msg.embeds[0])
            });
            collector.on("error", (e) => console.log(e))
        }
    };

    Structures.extend("TextChannel", () => TextChannel);
}